package com.dsic.gj_erp.bean.jhgk;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.dsic.gj_erp.bean.jhgk.dto.DzDoubleWeekNeedDto;
import com.dsic.gj_erp.bean.jhgk.dto.XzDoubleWeekNeedDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * <p>
 *
 * </p>
 *
 * @author xn
 * @since 2023-11-02
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="DmSygdxq对象", description="")
public class DmQfxq implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "分段")
    @TableField("DC_FD")
    private String dcFd;

    @ApiModelProperty(value = "总段号")
    private String zdh;

    @ApiModelProperty(value = "大组极重")
    private Double dzjz;

    @ApiModelProperty(value = "总装部最新分段需求期")
    private String zxfdxq;

    @ApiModelProperty(value = "钢料需求")
    private String xzglxq;
    private String dzglxq;
    @ApiModelProperty(value = "钢料需求")
    private String xzglxqOld;
    private String dzglxqOld;

    @ApiModelProperty(value = "X大板")
    private String xdb;

    @ApiModelProperty(value = "X数控件")
    private String xskj;

    @ApiModelProperty(value = "X平铁")
    private String xpt;

    @ApiModelProperty(value = "X压弯")
    private String xyw;

    @ApiModelProperty(value = "X型材")
    private String xxc;

    @ApiModelProperty(value = "X二次装T型材")
    private String xtxc;


    @ApiModelProperty(value = "D曲板")
    private String dqb;

    @ApiModelProperty(value = "D型材T")
    private String dxc;

    @ApiModelProperty(value = "D散件")
    private String dsj;

    @ApiModelProperty(value = "D大板")
    private String ddb;

    //fixme 取消注解
    @TableField(exist = false)
    private String dr150;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    private String dcCh;

    private String dcPl;

    //fixme 取消注解
    @TableField(exist = false)
    private String xzcd;//小组场地

    //fixme 取消注解
    @TableField(exist = false)
    private String dzcd;//大组场地

    //fixme 取消注解
    @TableField(exist = false)
    private String xok;//钢加回复,小组ok

    //fixme 取消注解
    @TableField(exist = false)
    private String dok;//钢加回复,大组ok

    //fixme 取消注解
    @TableField(exist = false)
    private String xbz;//小组备注

    //fixme 取消注解
    @TableField(exist = false)
    private String dbz;//大组备注

    private String drr;
    private String drrq;
    private String zt;
    private int drcs=1;

    @ApiModelProperty(value = "审核人员")
    private String shry;
    @ApiModelProperty(value = "审核日期")
    private String shrq;
    private String xqzt="0";

    @TableField(exist = false)
    private String fan;
    @TableField(exist = false)
    private String zt1;

    public String getCustomUniKey(){
        return StrUtil.format("{}_{}_{}",this.dcCh,this.dcPl,this.dcFd);
    }

    public void ofWithXzDWM0(XzDoubleWeekNeedDto dto){
        this.setXdb(dto.getDbXqrq());
        this.setXskj(dto.getSkjXqrq());
        this.setXpt(dto.getPtXqrq());
        this.setXyw(dto.getYwXqrq());
        this.setXxc(dto.getXcXqrq());
        this.setXzcd(dto.getXzcd());
    }

    public static DmQfxq ofWithXzDWM(XzDoubleWeekNeedDto dto){
        DmQfxq dmQfxq = new DmQfxq();
        dmQfxq.setDcCh(dto.getDcCh());
        dmQfxq.setDcPl(dto.getDcPl());
        dmQfxq.setDcFd(dto.getDcFd());

        dmQfxq.ofWithXzDWM0(dto);

        return dmQfxq;
    }

    public void ofWithDzDWM0(DzDoubleWeekNeedDto dto){
        this.setDzcd(dto.getDzcd());
        this.setDqb(dto.getQwbXqrq());
        this.setDdb(dto.getDbXqrq());
        this.setDxc(dto.getXcXqrq());
        this.setDsj(dto.getSjXqrq());
        this.setDr150(dto.getR150Xqrq());
    }

    public static DmQfxq ofWithDzDWM(DzDoubleWeekNeedDto dto){
        DmQfxq dmQfxq = new DmQfxq();
        dmQfxq.setDcCh(dto.getDcCh());
        dmQfxq.setDcPl(dto.getDcPl());
        dmQfxq.setDcFd(dto.getDcFd());

        dmQfxq.ofWithDzDWM0(dto);
        return dmQfxq;
    }
}
