package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.dto.DzDoubleWeekNeedDto;
import com.dsic.gj_erp.bean.jhgk.dto.XzDoubleWeekNeedDto;
import com.dsic.gj_erp.bean.jhgk.excel.GdxqExcel;
import com.dsic.gj_erp.bean.jhgk.excel.GdxqExcel1;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.exception.ServiceException;
import com.dsic.gj_erp.listeners.*;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-18
 */
@RestController
@RequestMapping("/dmQfxq")
public class DmQfxqController {

    @Autowired
    DmQfxqService service;
    @Autowired
    DmCbxxpService cbxxpService;

    //查询
    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody DmQfxq qfxq) {
        List<DmQfxq> list = service.list(new QueryWrapper<DmQfxq>()
                .eq(StrUtil.isNotEmpty(qfxq.getDcCh()), "dc_ch", qfxq.getDcCh())
                .eq(StrUtil.isNotEmpty(qfxq.getXzglxq()), "substring(Xzglxq,0,8) ", qfxq.getXzglxq())
                .eq(StrUtil.isNotEmpty(qfxq.getZt()), "zt", qfxq.getZt())
                .orderByAsc("DC_CH,dc_pl,DC_FD"));
        return new ResultBean(list);
    }

    @RequestMapping("/getCzxx")
    @AuthFunction
    public ResultBean getCzxx() {
        List<DmCbxxp> list = cbxxpService.list(new QueryWrapper<DmCbxxp>()
                .select("cbbm", "cbmc")
                .eq("wgbs", "N")
                .orderBy(true, true, "cbbm"));
        return new ResultBean(list);
    }

    @PostMapping("/uploadNew")
    public ResultBean<?> uploadNew(@RequestParam("file") List<MultipartFile> files,HttpServletRequest request) throws IOException {

        String username=(String) request.getAttribute("yhms");
        String day= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");

        List<DmQfxq> list=new ArrayList<>();
        HashMap<String, DmQfxq> map = new HashMap<>();

        for (MultipartFile file:files){
            if (StrUtil.contains(file.getOriginalFilename(),"小组双周")){
                CommonExcelListener<XzDoubleWeekNeedDto> commonExcelListener = new CommonExcelListener<>(file, XzDoubleWeekNeedDto.class);
                List<XzDoubleWeekNeedDto> objectList = commonExcelListener.readAndGetObjList();
                objectList.forEach(item->{
                    if (map.containsKey(item.getCustomUniKey())){
                        throw new ServiceException(9999,StrUtil.format("小组数据,船号:{},批量:{},分段:{}存在重复,请修正后再次上传"));
                    }
                    DmQfxq dmQfxq = DmQfxq.ofWithXzDWM(item);
                    dmQfxq.setDrr(username);
                    dmQfxq.setDrrq(day);
                    list.add(dmQfxq);
                    map.put(dmQfxq.getCustomUniKey(),dmQfxq);
                });
            }

            if (StrUtil.contains(file.getOriginalFilename(),"大组双周")){
                HashMap<String, DzDoubleWeekNeedDto> _map = new HashMap<>();
                CommonExcelListener<DzDoubleWeekNeedDto> commonExcelListener = new CommonExcelListener<>(file, DzDoubleWeekNeedDto.class);
                List<DzDoubleWeekNeedDto> objectList = commonExcelListener.readAndGetObjList();

                objectList.forEach(item->{
                    if (_map.containsKey(item.getCustomUniKey())){
                        throw new ServiceException(9999,StrUtil.format("大组数据,船号:{},批量:{},分段:{}存在重复,请修正后再次上传"));
                    }
                    _map.put(item.getCustomUniKey(),item);

                    DmQfxq dmQfxq = map.get(item.getCustomUniKey());
                    if (ObjUtil.isNotEmpty(dmQfxq)){
                        dmQfxq.ofWithDzDWM0(item);
                    }else{
                        dmQfxq=DmQfxq.ofWithDzDWM(item);
                        dmQfxq.setDrr(username);
                        dmQfxq.setDrrq(day);
                        list.add(dmQfxq);
                    }
                });
            }
        }

        service.saveOrUpdate(list);
        return new ResultBean<>();
    }

    //导入
    @PostMapping("/upload")
    @AuthFunction
    @ResponseBody
    public ResultBean uploadQf(@RequestParam("file") MultipartFile file, HttpServletRequest req) throws Exception, CustomException {

        ExcelGdxqListener objectListener = new ExcelGdxqListener();
        ExcelGdxq1Listener objectListener1 = new ExcelGdxq1Listener();

        EasyExcel.read(file.getInputStream(), GdxqExcel.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<GdxqExcel> objList = objectListener.getObjectList();

        EasyExcel.read(file.getInputStream(), GdxqExcel1.class, objectListener1).sheet(1).headRowNumber(1).doRead();
        List<GdxqExcel1> objList1 = objectListener1.getObjectList();


        List<DmQfxq> list = BeanUtil.copyToList(objList, DmQfxq.class);
        List<DmQfxq> list1 = BeanUtil.copyToList(objList1, DmQfxq.class);
        String username=(String) req.getAttribute("yhms");
        String day= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
         list= service.saveXzList(list,username,day);
         List<DmQfxq> list2=new ArrayList<>(list);
        if (list1.size()>0){
            list1= service.saveDzList(list1,username,day);
            for (DmQfxq qfxq : list1) {//循环大组
                for (DmQfxq dmQfxq : list) {//循环小组
                    if (qfxq.getId().equals(dmQfxq.getId())){//小组有
                       int index= list.indexOf(dmQfxq);
                        list2.set(index,qfxq);
                       break;
                    }
                }
                list2.add(qfxq);
            }
        }
        //下面代码注释是因为不再根据前方需求导入时生成作业计划,改为月度计划审批时生成
//        service.generateYdjh(list2);

        return new ResultBean(list2);
    }

    //保存
    @RequestMapping("/save")
    @AuthFunction
    public ResultBean save(@RequestBody List<DmQfxq> qfxqs) {
        service.saveBatch(qfxqs);
        return new ResultBean();
    }

    //删除
    @RequestMapping("/remove")
    @AuthFunction
    public ResultBean remove(@RequestBody List<DmQfxq> qfxqs) {
        List<String> idList=qfxqs.stream().map(DmQfxq::getId).collect(Collectors.toList());
        service.removeByIds(idList);
        return new ResultBean();
    }

    //提交/退回
    @RequestMapping("/qfxqTJ")
    @AuthFunction
    public ResultBean qfxqTJ(@RequestBody List<DmQfxq> qfxqs) {
        qfxqs.forEach(q -> {
            if (q.getZt().equals("0")) {
                q.setZt("1");
                return;
            }
            if (q.getZt().equals("1")) {
                q.setZt("0");
            }
        });
        service.updateBatchById(qfxqs);
        return new ResultBean();
    }

    //审核
    @RequestMapping("/qfxqSH")
    @AuthFunction
    public ResultBean qfxqSH(@RequestBody List<DmQfxq> qfxqs) {
        qfxqs.forEach(q -> {
            if (q.getZt().equals("1")) {
                q.setZt("2");
            }
        });
        service.updateBatchById(qfxqs);
        return new ResultBean();
    }


}
