package com.dsic.gj_erp.controller.kban;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.service.KbanService;
import com.dsic.gj_erp.service.jhgk.DmXbjhService;
import lombok.RequiredArgsConstructor;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.concurrent.atomic.AtomicInteger;

@Controller
@RequestMapping("kban")
@RequiredArgsConstructor
public class KanBanController {

    private final KbanService kbanService;
    private final DmXbjhService xbjhService;
    private final RedisTemplate<String,Object> redisTemplate;

    private String key="YdjhKban::";
    /**
     * 年度切割完成重量
     */
    @RequestMapping("ndwcl")
    public Object getndWcl() {
        String lastUpdateDate= (String) redisTemplate.opsForValue().get(key+"mbdcUpateTime");
        DateTime date = DateUtil.date();
        String today=date.toString("yyyyMMdd");
        if (today.equals(lastUpdateDate)){
            return "redirect:/YdjhKban/getMbdc";
        }else{
            return "redirect:/kban/getndWclOther";
        }
    }

    @RequestMapping("getndWclOther")
    @ResponseBody
    public Object getndWclOther() {
        DateTime date = DateUtil.date();
        String from = DateUtil.beginOfYear(date).toString("yyyy/MM/dd");
        String to = DateUtil.offsetDay(date,1).toString("yyyy/MM/dd");
        AtomicInteger maxVersion = xbjhService.getMaxVersion();
        String nf=DateUtil.thisYear()+"";
        //本年度线表总重量
        BigDecimal xbzl = xbjhService.getZlByNfAndVersion(nf, maxVersion.toString());
        //作业计划完成重量
        BigDecimal wgzl = kbanService.getWgzlByTime(from, to);
        BigDecimal jhwc = wgzl.divide(new BigDecimal("1000"), 4, RoundingMode.HALF_UP)
                .divide(xbzl, 1, RoundingMode.HALF_UP)
                .multiply(new BigDecimal("100"));
        return new ResultBean<>(new HashMap<String,Object>(){{
            put("jhwc",jhwc);
            put("ndgc",wgzl.divide(new BigDecimal("10000000"),2,RoundingMode.HALF_UP));
        }});
    }
}
