package com.dsic.gj_erp.listeners;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.Getter;
import lombok.Setter;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Consumer;

public class CommonExcelListener<T> extends AnalysisEventListener<T> {

    @Getter
    private List<T> objList =new ArrayList<>();

    @Getter
    @Setter
    private MultipartFile file;

    Consumer<T> action;

    private final Class<T> clazz;

    public CommonExcelListener(MultipartFile file,Class<T> clazz){
        this.file=file;
        this.clazz=clazz;
    }

    public CommonExcelListener(MultipartFile file,Class<T> clazz,Consumer<T> action){
        this.file=file;
        this.clazz=clazz;
        this.action=action;
    }

    @Override
    public void invoke(T t, AnalysisContext analysisContext) {
        if (this.action!=null){
            this.handler(t);
        }
        objList.add(t);
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {

    }

    public void handler(T t){
        action.accept(t);
    }

    public void read() throws IOException {
        EasyExcel.read(this.file.getInputStream(),clazz,this);
    }

    public List<T> readAndGetObjList() throws IOException {
        this.read();
        return this.objList;
    }
}